
$(window).bind('load', function()
{
 

    Media.add('youtube', 'youtube.com', "https?://(?:www\\.)?(?:youtube\\.com/).*(?:\\?|&)v=([\\w-]+)", {id: 1});
    Media.add('youtube', 'youtu.be', "https?://(?:www\\.)?youtu\\.be/([\\w-]+)", {id: 1});
    Media.add('vimeo', 'vimeo.com', "https?://(?:www\\.)?vimeo\\.com/([\\d]+)", {id: 1});
    Media.add('liveleak', 'liveleak.com', "https?://(?:www\\.)?(?:liveleak\\.com/).*(?:\\?|&)i=([\\w]+_\\d+)", {id: 1});
    Media.add('dailymotion', 'dailymotion.com', "https?://(?:www\\.)?dailymotion\\.com/video/([\\w]+)", {id: 1});
    Media.add('vocaroo', 'vocaroo.com', "https?://(?:www\\.)?vocaroo\\.com/i/([\\w]+)", {id: 1});
    Media.add('twitter', 'twitter.com', "https?://(?:www\\.)?twitter\\.com/.+/status/([\\d]+).*", {id: 1});

    /*
    Media.addGenerator('youtube', function(obj, cb){
        cb('<iframe src="//www.youtube.com/embed/' + obj.id + '?autoplay=1" width="640" height="360" frameborder="0" allowfullscreen></iframe>');
    });
    Media.addGenerator('vimeo', function(obj, cb){
        cb('<iframe src="//player.vimeo.com/video/' + obj.id + '?autoplay=1" width="640" height="360" frameborder="0" allowfullscreen></iframe>');
    });
    Media.addGenerator('liveleak', function(obj, cb){
        $.get( 'http://mobile.liveleak.com/view?i=' + obj.id + '&ajax=1', function( data ) {
            var regexp = /generate_embed_code_generator_html\('(\w+)'\)/i;
            var match = regexp.exec(data);
            if(!match || !match.hasOwnProperty('1')) return cb();
            cb('<iframe src="http://www.liveleak.com/ll_embed?f=' + match[1] + '&autostart=true" width="640" height="360" frameborder="0" allowfullscreen></iframe>');
        })
            .fail(function(){
                cb();
            });
    });
    Media.addGenerator('dailymotion', function(obj, cb){
        cb('<iframe width="640" height="360" src="//www.dailymotion.com/embed/video/' + obj.id + '?autoplay=1" frameborder="0" allowfullscreen></iframe>');
    });

    Media.addGenerator('vocaroo', function(obj, cb){
        cb('<object width="148" height="44"><param name="movie" value="//vocaroo.com/player.swf?playMediaID=' + obj.id + '&autoplay=1"></param><param name="wmode" value="transparent"></param><embed src="//vocaroo.com/player.swf?playMediaID=' + obj.id + '&autoplay=1" width="148" height="44" wmode="transparent" type="application/x-shockwave-flash"></embed></object>');
    });
    Media.addGenerator('twitter', function(obj, cb){
        var onsuccess = function( data ) {
            cb(data.html);
        };
        var onfail = function(){
            cb();
        };
        $.ajax( {
            url: '//api.twitter.com/1/statuses/oembed.json?lang=ru&maxwidth=700&id=' + obj.id + '&callback=?',
            dataType: 'json',
            timeout: 5000,
            success: onsuccess,
            error: onfail
        });
    });

    Media.addUnloader('twitter', function(el){
        $(el).closest('.post-message').find('.twitter-tweet').remove();
    });*/

    Media.addThumbnailer('youtube', function(obj){
        return '<img src="//i.ytimg.com/vi/' + obj.id + '/mqdefault.jpg" width="320" height="180">';
    });

    Media.addTitler('youtube', function(media, cb) {
        var jqxhr = $.get("https://www.googleapis.com/youtube/v3/videos?part=snippet&id=" + media.id + "&key=AIzaSyBw-cmbb0_u5bKx3ekgH9jaFfcN9CTLKD4", function(data) {
            if(!data) return cb(false);
            if(!data.items) return cb(false);
            if(!data.items[0]) return cb(false);
            if(!data.items[0].snippet) return cb(false);
            cb(data.items[0].snippet.title);
        });

        jqxhr.fail(function() {
            cb(false);
        })
    });

    Media.addMeta('youtube', {name: null, icon: '<i class="fa fa-youtube-play" style="color:red"></i>'});



    $('.main').append("<div id='media-thumbnail'></div>")
    var $links = $('.post-body').find('a').not('.post-link');
    Media.processLinks($links);

})


$(document).on('new_post', function(e,post) {
    $links = $(post).find('a').not('.post-link');
    Media.processLinks($links);
})










// Настройки

// old.media_thumbnails
// old.med_thumbnails_on_hover
// other.media.titler.max_workers'



//объект для работы с медиа ссылками (ютуб, ливлик, ...)
window.Media = {
    processors: [],
    generators: {},
    unloaders: {},
    thumbnailers: {},
    meta: {},

    //функция добавления нового "провайдера"
    //type - текст, пример "youtbe"
    //substr - текст, который должен быть в ссылке, чтоб испытывать на ней регулярку
    //regexp - текст, регулярное выражение для парсинга
    //fields - объект вида {id: 0, album: 1} тогда из регулярки будет возвращено {id: res[0], album: res[1]}
    add: function(type, substr, regexp, fields) {
        var regobj = new RegExp(regexp, 'i');
        this.processors.push([type, substr, regobj, fields]);
    },

    //добавление генератора плеера
    //type - текст, имя провайдера, пример "youtbe"
    //func - коллбек генератор, получает fields из регулярки и должен вернуть HTML текст плеера
    addGenerator: function(type, func) {
        this.generators[type] = func;
    },

    //добавить удалялку плеера при закрытии его кнопкой
    //type - текст, имя провайдера, пример "youtbe"
    //func - коллбек, получающий jQuery эллемент обработанной ссылки (<a href...)
    addUnloader: function(type, func) {
        this.unloaders[type] = func;
    },

    //добавить превью
    //type - текст, имя провайдера, пример "youtbe"
    //func - коллбек генератор, получает fields из регулярки и должен вернуть HTML текст плеера
    //должно вернуть HTML код превью (<img> например)
    addThumbnailer: function(type, func) {
        this.thumbnailers[type] = func;
    },

    //добавить генератор названия
    //type - текст, имя провайдера, пример "youtbe"
    //func - коллбек генератор, получает fields из регулярки и коллбек, который он должен вызвать с названием после того, как его вычислит
    addTitler: function(type, func) {
        this.titler.solvers[type] = func;
    },

    //добавить иконку и название сервиса
    //пример Media.addMeta('youtube', {name: 'YouTube', icon: '<i class="fa fa-media-icon media-meta-youtube-icon"></i>'});
    addMeta: function(type, meta) {
        this.meta[type] = meta;
    },

    //обработчик ссылок, определяющий есть ли в ссылке медиа и возвращающий её fields если есть
    parse: function(url) {
        var proc_len = this.processors.length;
        var ret;

        for(var i=0;i<proc_len;i++) {
            var proc = this.processors[i];
            if(url.indexOf(proc[1]) < 0) continue; //proc[1] это текст, который будет искаться в ссылке

            ret = this.getValues(url, proc);
            if(ret) break;
        }

        return ret;
    },

    //фнкция для получения fields из ссылки
    getValues: function(url, proc) {
        var type = proc[0];
        var regexp = proc[2];
        var fields = proc[3];
        var values = {type: type};

        var reg_result = regexp.exec(url);
        if(!reg_result) return false;

        for(var field_name in fields) {
            if(!fields.hasOwnProperty(field_name)) continue;
            if(!reg_result.hasOwnProperty(fields[field_name])) return false;

            values[field_name] = reg_result[fields[field_name]];
        }

        return values;
    },

    //внутренняя функция для получения HTML плеера
    getEmbedCode: function(type, id, cb) { //переписать если вдруг появится что-то кроме ID. Не хочу пачкать "data-" ради совместимости
        this.generators[type]({id: id}, cb);
    },

    //внутренняя функция для обработки сырых <a href...>
    //поиска медиа ссылок
    //рендера кнопок для них
    processLinks: function(el) {
        el.each(function(){
            var $el = $(this);
            var url = $el.text();
            var obj = Media.parse(url); //если ничего не вернуло, значит это не медиа ссылка
            if(!obj) return;            //пропускаем
            var $post = el.closest('.post');

            //разбираемся с превьюшкой
            if(Media.thumbnailers.hasOwnProperty(obj.type) && getKey('old.media_thumbnails', true)) {
                var on_hover = getKey('old.media_thumbnails_on_hover', true);
                var thumbnail = $('<div class="media-thumbnail" ' + (on_hover?'style="display:none"':'') + '>' + Media.thumbnailers[obj.type](obj) + '</div>');
                var mthumbnail = $('#media-thumbnail');

                //если в настройках выставлен показ при наводе мыши
                if(on_hover) {
                    $el.hover(function(e){
                        mthumbnail
                            .append(thumbnail)
                            .css({
                                position: 'absolute',
                                display: 'block',
                                'z-index': '999',
                                top: e.pageY + 'px',
                                left: e.pageX + 'px'
                            });
                        thumbnail.show();
                    });
                    $el.mouseout(function(){
                        thumbnail.hide();
                        mthumbnail.hide();
                    });
                    $el.mousemove(function(e){
                        mthumbnail
                            .css({
                                top: (e.pageY - 10) + 'px',
                                left: (e.pageX + 30) + 'px'
                            });
                    });
                }else{
                    $button_expand.append(thumbnail);
                }
            }

            Media.titler.solve($el, obj);
            //костыли костылики для открытия твиттов после загрузки
            if(obj.type == 'twitter' && window.config.twitter_autoexpand-- > 0) $button_expand.click();
        });
    },

    //целый объект для работы с тайтлами медий
    titler: {
        solvers: {},
        queue: {},
        active_workers: 0,

        solve: function($href, media) {
            if(!this.solvers[media.type]) return;
            var title = getKey('_cache.media.' + media.type + '.' + media.id + '.title', false);
            if(title !== false) return this.renderTitle($href, title, media);
            if(this.queue[media.type+media.id]) {
                this.queue[media.type+media.id]['hrefs'].push($href);
            }else{
                this.queue[media.type+media.id] = {media: media, hrefs: [$href]};
                this.prepareNewWorker();
            }
        },

        prepareNewWorker: function() {
            if(this.active_workers >= getKey('other.media.titler.max_workers', 2)) return;

            for(var key in this.queue) {
                if(!this.queue.hasOwnProperty(key)) continue;
                if(this.queue[key].active) continue;
                return this.startWorker(key);
            }
        },

        startWorker: function(queue_key) {
            this.active_workers++;
            this.queue[queue_key].active = true;
            var media = this.queue[queue_key].media;
            var solver = this.solvers[media.type];
            var worker = this;

            solver(media, function(title) {
                worker.active_workers--;
                if(title) {
                    worker.processHrefs(queue_key, title);
                    setKey('_cache.media.' + media.type + '.' + media.id + '.title', title);
                    setKey('_cache.media.' + media.type + '.' + media.id + '.created', Math.ceil((+new Date)/1000));
                }
                delete worker.queue[queue_key];
                worker.prepareNewWorker();
            });
        },

        processHrefs: function(queue_key, title) {
            var hrefs = this.queue[queue_key]['hrefs'];
            for(var i=0;i<hrefs.length;i++) this.renderTitle(hrefs[i], title, this.queue[queue_key].media);
        },

        renderTitle: function($href, name, media) {
            var meta = Media.meta[media.type];
            if(meta) {
                $href.before(meta.icon);
                $href.html("  " + name);
            }else{
                $href.html(name);
            }
        }
    }
};


