<?php
require "./inc/functions.php";
header('Content-Type: text/json; charset=utf-8');


if (get_magic_quotes_gpc()) {
	function strip_array($var) {
		return is_array($var) ? array_map('strip_array', $var) : stripslashes($var);
	}
	
	$_GET = strip_array($_GET);
	$_POST = strip_array($_POST);
}


if(!isset($_POST['action'], $_POST['trip'], $_POST['id'], $_POST['board']))
{
    response(array('alert'=>'нехватает параметров'));
}

/* check tripcode */
$mod_trip = generate_tripcode($_POST['trip']); 
 
if(count($mod_trip) < 2)
    response(array('wrong_trip' => '1'));
else
    $mod_trip = $mod_trip[1];


if (!openBoard($_POST['board']))
    response(array('wrong_params' => '1'));



switch($_POST['action'])
{

    case 'login':
        opmod_login($_POST['id'], $mod_trip);
        break;
    case 'delete_post':
        opmod_delete_post($_POST['id'], $mod_trip);
        break;
    default:
        response(array('error'=>'unkhown request'));
}


function opmod_login($thread_id, $mod_trip)
{
    global $board, $mod_trip;

    $query = prepare(sprintf("SELECT `thread`, `trip` FROM ``posts_%s`` WHERE `id` = :id", $board['uri']));
    $query->bindValue(':id', $thread_id, PDO::PARAM_INT);
    $query->execute() or error(db_error($query));
    $thread = $query->fetch(PDO::FETCH_ASSOC);

    if(!$thread)
        response(array('alert'=> 'Тред не найден'));
    if (!empty($thread['trip']) && $mod_trip ==  $thread['trip'])
        response(array('login_success'=>'1'));
    else
        response(array('login_fail'=>'1'));


}

function opmod_delete_post($id, $mod_trip)
{
    global $board, $mod_trip;

    $query = prepare(sprintf("SELECT `thread`, `time` FROM ``posts_%s`` WHERE `id` = :id", $board['uri']));
    $query->bindValue(':id', $id, PDO::PARAM_INT);
    $query->execute() or error(db_error($query));
    
    if ($post = $query->fetch(PDO::FETCH_ASSOC)) 
    {

        $thread = false;

        if ($post['thread'])
        {
            $thread_query = prepare(sprintf("SELECT `time`,`trip` FROM ``posts_%s`` WHERE `id` = :id", $board['uri']));
            $thread_query->bindValue(':id', $post['thread'], PDO::PARAM_INT);
            $thread_query->execute() or error(db_error($query));

            $thread = $thread_query->fetch(PDO::FETCH_ASSOC);	


 
				deletePost($id);
                modLog("User deleted his own post #$id");

                _syslog(LOG_INFO, 'Deleted post: ' .
				'/' . $board['dir'] . $config['dir']['res'] . sprintf($config['file_page'], $post['thread'] ? $post['thread'] : $id) . ($post['thread'] ? '#' . $id : '')
                );
 

        }
        else
        {
            response(array('alert'=>'Пост не найден'));
        }
    }

    // We are already done, let's continue our heavy-lifting work in the background (if we run off FastCGI)
    //if (function_exists('fastcgi_finish_request'))
    //    @fastcgi_finish_request();

    rebuildThemes('post-delete', $board['uri']);
 
    response(array('post_delete_success'=>'1'));
}

function response($arr)
{
    die(json_encode($arr));
}





?>
